
% This code plots a graph for different number of bad labelers vs accuracy

%use MatlabProcessManager
%use MatlabStan
clear all;

prompt = 'Which dataset do you want to use? Enter 1 for IRIS, 2 for Breast Cancer, 3 for TIC_TAC_TOE, and 0 to exit \n   ';
dataset_choice = input(prompt)

% dataset_choice = input(prompt,'s')
% if isstr(dataset_choice)==0
%     display('yes')
%     dataset_choice =str2num(dataset_choice)
% end
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%(
%
% %%%%%%%%%%%%%%%%  IRIS      %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% while (isempty(dataset_choice))||(dataset_choice ~= 0) ||(dataset_choice ~= 1)||(dataset_choice ~= 2)||(dataset_choice ~= 3)
if dataset_choice ==1
    probZ1 = 0.5;
    load fisheriris;
    % data1=meas(1:30,:);
    % data2=meas(61:90,:);
    % data=[data1;data2];
    % size(data)
    
    data=meas(1:100,:);
    
    N=size(data,1);% instances
    D=size(data,2);
    M= 20; % Crowd labelers
    X=ones(50,1);
    Y=ones(50,1);
    Y=-Y;
    Z=zeros(50,1);
    groundTruth= [X; Y];
    GT=[X;Z];
    
    K=2;% number of clusters/ Expert labels
    S=4; % number of instances per cluster to be labeled by the experts
    disp('IRIS');
    display('Number of expert labels');
    P=K*S
    display('Number of Crowd labelers');
    M
    display('Number of instances');
    N
    
elseif dataset_choice==2
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%%%  BREAST CANCER %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    clear all;
    probZ1 = 0.5;
    %  N = 569;% instances
    
    N = 56;% instances
    M = 20;% Crowd labelers
    load breast_cancer.parsed;
    data=breast_cancer(1:N,4:34);
    
    GT=breast_cancer(1:N,2);
    for i=1:N
        if GT(i)==0
            groundTruth(i)= -1;
        else
            groundTruth(i)= 1;
        end
    end
    groundTruth=groundTruth';
    K=2;% number of clusters/ Expert labels
    D=size(data,2);
    S=4; % number of instances per cluster to be labeled by the experts
    disp('BREAST CANCER');
    display('Number of expert labels');
    P=K*S
    display('Number of Crowd labelers');
    M
    display('Number of instances');
    N
    
    %
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    %%%%%%%%%%%%%%% TIC_TAC_TOE     %%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
elseif dataset_choice==3
    
    
    clear all;
    probZ1 = 0.5;
    N = 958;% instances
    M = 20;% Crowd labelers
    load tic-tac.parsed; %1:626 and 627:958
    data=tic_tac(1:N,2:28);
    
    GT=tic_tac(1:N,29);
    
    for i=1:N
        if GT(i)==0
            groundTruth(i)= -1;
        else
            groundTruth(i)= 1;
        end
    end
    groundTruth=groundTruth';
    K=2;% number of clusters/ Expert labels
    D=size(data,2);
    S=40; % number of instances per cluster to be labeled by the experts
    
    disp('TIC_TAC_TOE');
    display('Number of expert labels');
    P=K*S
    display('Number of Crowd labelers');
    M
    display('Number of instances');
    N
    
elseif dataset_choice == 0
    display('Bye')
    return
elseif isempty(dataset_choice)
    display('No choice made. Bye')
    return
  
elseif  isstr(dataset_choice)
    display('Numbers only. Wrong choice. Bye.')
    return
           
%            end
    
else
    display('Wrong choice. Bye.')
 
    return
    
end



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%  CHESS      %%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% clear all;
% probZ1 = 0.5;
% N = 3196;% instances
% M = 20;% Crowd labelers
% load chess.parsed;
% data=chess(1:N,2:37);
%
% GT=chess(1:N,38);
% for i=1:N
%     if GT(i)==0
%         groundTruth(i)= -1;
%     else
%          groundTruth(i)= 1;
%     end
% end
% groundTruth=groundTruth';
% K=2;% number of clusters/ Expert labels
% D=size(data,2);
% S=4; % number of instances per cluster to be labeled by the experts
% disp('CHESS');
% display('Number of expert labels');
% P=K*S
% display('Number of Crowd labelers');
% M
% display('Number of instances');
% N


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%   MUSHROOM   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% clear all;
% probZ1 = 0.5;
% M = 20;% Crowd labelers
% load mushrooom.parsed;
%
%
% % N = 500;% instances
% % A=find(mushrooom(:,118)==1);
% % B=find(mushrooom(:,118)==0);
% % a=A(1:N/2);
% % b=B(1:N/2);
% % d=[a;b];
% % c = d(randperm(length(d)) ); % shuffle
% % data1=mushrooom(c,2:52);  %removing columns with missing values
% % data2=mushrooom(c,57:117);
% % data=[data1,data2];
% % GT=mushrooom(c,118);
%
% % If the all 8124 instances are to be used then uncomment the following
% N=size(mushrooom,1);
% data1=mushrooom(1:N,2:52);  %removing columns with missing values
% data2=mushrooom(1:N,57:117);
% data=[data1,data2];
% GT=mushrooom(1:N,118);
%
% for i=1:N
%     if GT(i)==0
%         groundTruth(i)= -1;
%     else
%          groundTruth(i)= 1;
%     end
% end
%
% groundTruth=groundTruth';
% K=2;% number of clusters
% D=size(data,2);
% S=10; % number of instances per cluster to be labeled by the experts
% disp('MUSHROOM');
% display('Number of expert labels');
% P=K*S
% display('Number of Crowd labelers');
% M
% display('Number of instances');
% N
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


total=11;
R=zeros(length(total),M);
Time1=zeros(1,total);
Time2=zeros(1,total);
Time3=zeros(1,total);
Time4=zeros(1,total);
MV=zeros(1,total);
GWO=zeros(1,total);
GW=zeros(1,total);
EC=zeros(1,total);
E=zeros(1,total);

% --------------------------------------------------------------------------
% Initialization
% --------------------------------------------------------------------------
runs=2
I=K*S;
r=zeros(1,M);
error=0:0.1:1;

for count=1:total
    count
    
    bad=round(error(count)*M)
    
    for k=1:M
        %r(k)=0.2*rand;
        if k<=bad
            %             r(k)=(1-0.6)*rand+0.6;
            
            r(k)=(1-0.4)*rand+0.4;
            %
            %                       r(k)=(0.6-0.4)*rand+0.4;
            %             r(k)=(1-0.7)*rand+0.7;
            
            % r(k)=0.1*rand;
            %              r(k)=rand;
            
        else
            %            r(k)=rand;
            %              r(k)=(1-0.9)*rand+0.9;
            %             r(k)=(0.6-0.4)*rand+0.4;
            r(k)=0.3*rand;
        end
    end
    wrong=cell(1,M); % celll will contain the wrong labels given by M labelers
    for j=1:M
        
        W=floor(r(j)*N);    % number of wrong labels
        while length(wrong{j}) < W % checks if the cell has W elements or not
            
            WW=floor(N*rand); % generated a random number
            
            if WW==0   % checks if zero
                WW=WW+1;
            end
            wrong{j} = [wrong{j};WW]; % appends the random number to the cell
            
            wrong{j} = unique(wrong{j}); % keeps the unique numbers
            
            wrong{j} = sort(wrong{j});
        end
        
    end
    
    labels=repmat(groundTruth,1,M);
    
    for i=1:M
        for k=1:length(wrong{i})
            labels(wrong{i}(k),i)=-labels(wrong{i}(k),i);
        end
    end
    
    
    
    % Initialize given labels for Glad
    idx = 1;
    for i = 1:M
        for j = 1:N
            itemIds(idx) = j;
            labelerIds(idx) = i;
            
            
            Labels(idx)=labels(j,i);
            
            idx = idx + 1;
        end
    end
    
    
    
    
    
    % --------------------------------------------------------------------------
    % Majority voting
    % --------------------------------------------------------------------------
    tic
    
    [m_vote, V] =majority_voting(labels,groundTruth);
    T1=toc;
    
    
    
    for run=1:runs
        
        
        %-----------------------------------------------------------------
        
        % Other Methods
        %-----------------------------------------------------------------
        
        L=zeros(size(labels));
        
        for i=1:size(labels,1)
            for j=1:size(labels,2)
                if labels(i,j)==-1
                    L(i,j)=2;
                else
                    L(i,j)=1;
                    
                end
            end
        end
        
        
        true_labels=zeros(size(groundTruth));
        
        for i=1:size(groundTruth)
            if groundTruth(i)==-1
                true_labels(i)=2;
            else
                true_labels(i)=1;
                
            end
        end
        true_labels=true_labels';
        
        
        
        
        
        Model = crowd_model(L); % compile the information into a data structure,
        %% Baseline algorithms
        % majority voting
        %         Key_mvote = marjority_vote_crow_model(Model);
        %         prob_error_mvote = mean(Key_mvote.ans_labels ~= true_labels);
        %         fprintf('Error rate of majority voting: %f\n', prob_error_mvote);
        %         fprintf('+++++++++++++++++++\n');
        %         MV1(run)=1- prob_error_mvote
        %
        %         fprintf('+++++++++++++++++++\n');
        
        % EM, two coin model (Dawid & Skene)
        options = {'maxIter', 100, 'TOL', 1e-3};%, 'prior_workers', 1.001*ones(2,2)};
        Key_em =  EM_two_coin_crowd_model(Model, options{:});
        prob_error_em = mean(Key_em.ans_labels ~= true_labels);
        fprintf('Error rate of EM two-coin: %f\n', prob_error_em);
        fprintf('+++++++++++++++++++\n');
        DV1(run)=1-prob_error_em;
        fprintf('+++++++++++++++++++\n');
        % EM, one coin model
        options = {'maxIter', 100, 'TOL', 1e-3};%, 'prior_workers', 1.001*ones(2,2)};
        Key_em_1 =  EM_one_coin_crowd_model(Model, options{:});
        prob_error_em_1 = mean(Key_em_1.ans_labels ~= true_labels);
        fprintf('Error rate of EM two-coin: %f\n', prob_error_em_1);
        fprintf('+++++++++++++++++++\n');
        DV2(run)=1-prob_error_em_1;
        fprintf('+++++++++++++++++++\n');
        
        %% BP algorithms
        % Belief propagation on one-coin model with Beta(2,1) prior (Liu et al 12)
        options = {'prior', 'beta', 'ell', [2,1], 'maxIter',100, 'TOL', 1e-3};
        Key_BP21 = sum_FBP_one_coin_crowd_model(Model, options{:});
        prob_error_BP21 = mean(Key_BP21.ans_labels ~= true_labels);
        fprintf('Error rate of BP one coin Beta(2,1): %f\n', prob_error_BP21);
        fprintf('+++++++++++++++++++\n');
        BP1(run)=1-prob_error_BP21;
        fprintf('+++++++++++++++++++\n');
        
        % Belief propagation on two-coin model with Beta(2,1) & Beta(2,1) prior (Liu et al 12)
        options = {'prior', 'beta', 'ell1', [2,1], 'ell2', [2,1],  'maxIter', 100, 'TOL', 1e-3};
        Key_BPAB21 = sum_FBP_two_coin_crowd_model(Model, options{:});
        prob_error_BPAB21 = mean(Key_BPAB21.ans_labels ~= true_labels);
        fprintf('Error rate of BP two coin Beta(2,1): %f\n', prob_error_BPAB21);
        fprintf('+++++++++++++++++++\n');
        BP2(run)=1-prob_error_BPAB21;
        fprintf('+++++++++++++++++++\n');
        
        %% mean field algorithms
        % mean field on one-coin model (uniform prior)
        Key_MF11 = variationalEM_one_coin_crowd_model(Model, 'ell', [2,1], 'maxIter',100, 'TOL', 1e-3);
        prob_error_MF11 = mean(Key_MF11.ans_labels ~= true_labels);
        fprintf('Error rate of mean field one coin: %f\n', prob_error_MF11);
        fprintf('+++++++++++++++++++\n');
        MF1(run)=1-prob_error_MF11;
        fprintf('+++++++++++++++++++\n');
        
        % mean field on two-coin model (Beta(2,1) prior)
        Key_MFAB11 = variationalEM_two_coin_crowd_model(Model, 'ell', [2,1;1,2], 'maxIter',100, 'TOL', 1e-3);
        prob_error_MFAB11 = mean(Key_MFAB11.ans_labels ~= true_labels);
        fprintf('Error rate of mean field two coin: %f\n', prob_error_MFAB11);
        fprintf('+++++++++++++++++++\n');
        MF2(run)=1- prob_error_MFAB11;
        fprintf('+++++++++++++++++++\n');
        
        %% KOS algorithms in Karger, Oh, Shah. 2011
        % this version closely follows the implementation in [KOS]: initializing messages to Norm(1,1), and run only for 10 iterations.
        verbose = 1;
        options = {'maxIter',10, 'TOL', 0, 'initialMsg', 'ones+noise', 'verbose', verbose};
        Key_kos10 = KOS_method_crowd_model(Model, options{:});
        prob_error_kos10 = mean(Key_kos10.ans_labels ~= true_labels);
        fprintf('Error rate of KOS-iteration10: %f\n', prob_error_kos10);
        fprintf('+++++++++++++++++++\n');
        KOS1(run)=1- prob_error_kos10;
        fprintf('+++++++++++++++++++\n');
        
        % KOS again, but with parameters closer to that of BP (initialize to uniform messages (initialMsg='ones') and maxIter=100)
        options = {'maxIter',100, 'TOL', 1e-7, 'initialMsg', 'ones', 'verbose', verbose};
        Key_kos100 = KOS_method_crowd_model(Model, options{:});
        prob_error_kos100 = mean(Key_kos100.ans_labels ~= true_labels);
        fprintf('Error rate of KOS-iteration100: %f\n', prob_error_kos100);
        fprintf('+++++++++++++++++++\n');
        KOS2(run)=1- prob_error_kos100;
        fprintf('+++++++++++++++++++\n');
        
        
        
        
        %     % --------------------------------------------------------------------------
        %     % Glad
        %     % --------------------------------------------------------------------------
        %
        % G=glad(Labels,groundTruth,itemIds,labelerIds)
        tic
        [G_without,G_clamp]=glad(probZ1,N,M,itemIds,labelerIds,GT,Labels);
        T2=toc;
        G1(run)=G_without;
        G2(run)=G_clamp;
        
        % --------------------------------------------------------------------------
        %  ELICE  1
        % --------------------------------------------------------------------------
        
        
        %%% ELICE 1 regular
        
        [elice_r1]=rand_elice(labels, groundTruth,I);
        
        Elice_r1(run)=elice_r1;
        
        
        %%%%% ELICE 1 with clustering
        
        
        [elice_c1,alphas,old_betas,index]=elice_cluster(labels, groundTruth,K,data,S);
        
        Elice_c1(run)=elice_c1;
        
        
        
        
        % --------------------------------------------------------------------------
        %  ELICE  2
        % --------------------------------------------------------------------------
        
        %%%%% ELICE 2 regular
        
        [elice_r2,old_alphas,old_betas,indx]=elice_entropy(labels, groundTruth,I);
        Elice_r2(run)=elice_r2;
        
        
        %%%%% ELICE 2 with clustering
        
        
        [elice_c2]=elice_entropy_cluster(labels,groundTruth,K,data,S);
        
        Elice_c2(run)=elice_c2;
        T4=toc;
        
        % --------------------------------------------------------------------------
        % ELICE 3  WITH PAIRWISE COMPARISON
        % --------------------------------------------------------------------------
        
        %%%%% ELICE 3 pairwise
        [e_p3]=elice_pairwise(N,M,old_alphas, old_betas,indx,labels,groundTruth);
        E_P3(run)=e_p3;
        
        
        %%%%% ELICE 3 circular
        [e_c3]=elice_circular(N,M,old_alphas, old_betas,indx,labels,groundTruth);
        E_C3(run)=e_c3;
        
    end
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    MV(count)=m_vote;  % Majority Voting
    GWO(count)=mean(G1); %GLAD
    GW(count)=mean(G2);  %GLAD with clamping
    
    
    E1(count)=mean(Elice_r1); %%% ELICE 1 regular
    EC1(count)=mean( Elice_c1); %%%%% ELICE 1 with clustering
    
    E2(count)=mean(Elice_r2);  %%%%% ELICE 2 regular
    EC2(count)=mean( Elice_c2); %%%%% ELICE 2 with clustering
    
    
    
    EP3(count)=mean(E_P3); %%%%% ELICE 3 pairwise
    EC3(count)=mean(E_C3); %%%%% ELICE 3 circular
    
    
    DV_1(count)=mean(DV1); % Dawid and Skene
    DV_2(count)=mean(DV2);
    
    BP_1(count)=mean(BP1); % Belief Propagation
    BP_2(count)=mean(BP2);
    
    MF_1(count)=mean(MF1);  % Mean Field
    MF_2(count)=mean(MF2);
    
    KOS_1(count)=mean(KOS1);  % Karger
    KOS_2(count)=mean(KOS2);
    
end

MV
GWO
GW

E1
EC1
E2
EC2
EP3
EC3

DV_1
DV_2

BP_1
BP_2

MF_1
MF_2

KOS_1
KOS_2





% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%% Plot %%%%%%%%%%%%%%%%%%%%%%%%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
xlab=0:0.1:1;

figure(1);
clf;
axes('FontSize',14);
hold on;
box on;
hold on;
axis([0 1.02 0 1.02])
hold on;

plot(xlab,MV,'-.c*');
hold on;
plot(xlab, GWO,'-.kV');
hold on;
plot(xlab,GW,'-.rs');
hold on;
% plot(xlab,IL,'-.gd');
% hold on;



% plot(xlab,MV_1,'-.r*');
% hold on;
plot(xlab, DV_1,'-.kd');
hold on;
plot(xlab,DV_2,'-.gs');
hold on;
plot(xlab,MF_1,'-.bd');
hold on;
plot( xlab,MF_2,'-.rs');
hold on;
plot(xlab,BP_1,'-.kV');

plot( xlab,BP_2,'-.g<');
hold on;
plot(xlab,KOS_1,'-.bs');
hold on;
plot(xlab,KOS_2,'-.rd');
hold on;

plot( xlab,E1,'-<c');
hold on;
plot(xlab,EC1,'-ro');

plot( xlab,E2,'-<b');
hold on;
plot(xlab,EC2,'-mo');
hold on;
plot(xlab,EP3,'-kp');
hold on;
plot(xlab,EC3,'-gh');
hold on;


% title('IRIS dataset. Good vs. Random and Malicious Labelers-');
%  title('IRIS dataset. Random and malicious labelers-');
% title('IRIS dataset. Good and malicious labelers-');
% title('IRIS dataset. Good and random labelers-');

title('UCI Breast Cancer dataset. Good and random/malicious labelers-');

%  title('UCI Breast Cancer dataset. Good and Random Labelers-');
%  title('UCI Breast Cancer dataset. Good and Malicious labelers-');
hleg = legend('Majority Voting.','GLAD','GLAD with Clamping.','Dawid & Skene1','Dawid & Skene2','Mean Field1','Mean Field2','Belief Propagation1','Belief Propagation2','Karger1','Karger2','ELICE 1','ELICE 1 with Clustering.','ELICE 2','ELICE 2 with Clustering.','ELICE 3 Pairwise','ELICE 3 Circular','Location','eastoutside');
xlabel('Percentage of malicious labelers.')
%  xlabel('Percentage of random labelers.')
% xlabel('Percentage of random and malcious labelers.')

ylabel('Accuracy')
% print('-dpng', 'Good and Random Labelers and Accuracy BC Dec2015');

% print('-dpng', 'Good and Random and Malicious Labelers and Accuracy BC Dec2015');
% print('-dpng', 'Random and Malicious Labelers and Accuracy BC Dec2015');

% print('-dpng', 'Good and Malicious Labelers and Accuracy BC Dec2015');

% print('-depsc', 'Bad Labelers and Accuracy BC March2015');

